Btrieve Components for Delphi

Btrieve Components for Delphi from Summit National Group provides a native set of tools for Delphi which bring the object-oriented technology of Delphi together with the rapid data access, Client-Server, Navigational model of Btrieve.  All documentation is on-line and integrated with the Delphi Help system and cross-linked with both the Delphi and Component Writers Guide Help files.

Source Components

Driver Components

Editing Components

Lookup Components

Miscellaneous Components

See Also

Purchase

Installation

Deliverables

BTRVCMP1.DCU, BTRVCMP1.DCR, BTRVCMP2.DCU, BTRVCMP2.DCR, BTRVCMP2.RES

BTRVCOMP.HLP. BTRVCOMP.KWF

Requirements

Delphi from Borland International (408.431.1000)

Special Note: Variable Length records are not supported in the current release

License Agreement

Copyright  1995 Summit National Group, Inc. .  All rights reserved.  All Summit National Group, Inc. products are trademarks or registered trademarks of Summit National Group, Inc. .  Other brand and product names are trademarks or registered trademarks of their respective holders.


  Summit National Group

Btrieve Components for Delphi are native Delphi components that directly access Btrieve for applications written in Delphi without replacing any Delphi functionality.

Summit National Group has been developing software for the Equipment Leasing industry since 1984.  The modules available include Lease Accounting, Lease Analysis, Application Processing, General Ledger, Fixed Assets, Credit Bureau Reporting, Electronic Banking (ACH) and AVP.  All of these applications are Btrieve based and are compatible with Novell and Lantastic networks.

For further information contact:

Summit National Group

230 East Ohio Street, 6th Floor

Chicago, IL  60611	USA

voice:	800 621 9531 or 312 944 3100

fax:	312 944 8346

CIS:	73420,3727


GetVersion Method

Applies to

BtrvDB

Declaration

procedure GetVersion:;

Description

Gets the version of the Btrieve Engine and stores it in the member Fversion.

This is accomplished with the Btrieve GetVersion command.


TBtrvDB

  TBtrvDB Component

Properties	Methods

Unit

BtrvCmp1

Parent

TComponent

Description

A TBtrvDB component is a Source Component.  TBtrvDB maintains contact with the Btrieve engine.  It also handles all non-file related functionality.  This component is always invisible.

This component starts and stops Btrieve for your Delphi application.  If Btrieve is not available, it throws an EBtrvException.

Note:  TBtrvDB should only be placed on the MainForm of your application.  Only one is necessary.


TBtrvFile

  TBtrvFile Component

Properties	Methods	Member

Unit

BtrvCmp1

Parent

TComponent

Description

A TBtrvFile component is a Source Component.  TBtrvFile needs to be present on the form where a Btrieve data file is being accessed.  It handles all file related Btrieve functionality such as GetFirst, GetNextExtended, etc...  It is identified as the BtrvFile by any Btrieve Components for Delphi components that want to access the particular file.

Note:	This component is always invisible.


TBtrvDriverListBox

  TBtrvDriverListBox Component

Properties

Unit

BtrvCmp2

Parent

TListBox

Description

A TBtrvDriverListBox is a Driver Component.  TBtrvDriverListBox interacts with its BtrvFile so that a position in the Btrieve data file can be established and all other Editing Components on that form that have an identical BtrvFile as the TBtrvDriverListBox are reflecting the information in the record selected by the TBtrvDriverListBox.  If an item is selected with which to update all the Editing Components, and that item represents more than one record, an EBtrvException will be thrown unless the Chained property is not nil.  If the Chained property is not nil, then the new TFilter will be passed to the TBtrvDriverListBox indicated by the Chained property.


Driver Component

Driver Components

Driver components manage the data flow on a form.  When the a selection is made by the driver component, the BtrvFile of the Driver Component will position itself on the record that matches the selected item.  All other components on the form that have that BtrvFile will then be similarly updated with that record.

Driver Components

TBtrvDriverComboBox

TBtrvDriverListBox

Note: If the driver component is a TBtrvDriverComboBox and the application user enters a new item in the data field of the combo box, the driver component notifies its BtrvFile of a new record which then positions itself on a new, blank record.

See Also

Source Component

Editing Component

Lookup Component

Miscellaneous Component


TBtrvDriverComboBox

  TBtrvDriverComboBox Component

Properties

Unit

BtrvCmp2

Parent

TComboBox

Description

A TBtrvDriverComboBox is a Driver Component.  TBtrvDriverComboBox interacts with its BtrvFile so that a position in the Btrieve data file can be established and all other Editing Components on that form that have an identical BtrvFile as the TBtrvDriverComboBox are reflecting the information in the record selected by the TBtrvDriverComboBox.  If the user enters a new item in the TBtrvDriverComboBox then the BtrvFile is positioned on a new record and all the editing components associated with that BtrvFile assume their default value.  If an item is selected with which to update all the Editing Components, and that item represents more than one record, an EBtrvException will be thrown.


TBtrvLookupListBox

  TBtrvLookupListBox Component

Properties

Unit

BtrvCmp2

Parent

TListBox

Description

A TBtrvLookupListBox is a Lookup Component. TBtrvLookupListBox uses two BtrvFiles, BtrvReadFile for populating the list, the BtrvFile for writing the selection of the list.

An example of its usage would be in populating the list with automobile manufacturers from a AutoManufacturer Table and having the component write the selected item into the Auto Table at the current record.  If an item is selected with which to update all the Editing Components, and that item represents more than one record, an EBtrvException will be thrown.

See Also

TBtrvLookupComboBox


TBtrvLookupComboBox

  TBtrvLookupComboBox Component

Properties

Unit

BtrvCmp2

Parent

TComboBox

Description

A TBtrvLookupComboBox is a Lookup Component.  TBtrvLookupListBox uses two BtrvFiles, BtrvReadFile for populating the list, the BtrvFile for writing the selection of the list.  When a new item is entered into TBtrvLookupComboBox, a new record is created in the BtrvReadFile.  If an item is selected with which to update all the Editing Components, and that item represents more than one record, an EBtrvException will be thrown.

See Also

TBtrvLookupListBox


TBtrvListBox

  TBtrvListBox Component

Properties

Unit

BtrvCmp2

Parent

TListBox

Description

A TBtrvListBox is an Editing Component.  TBtrvListBox allows the programmer to populate the list with values, not from a Btrieve data file and have the selected value written to the record of the BtrvFile of the TBtrvListBox.


TBtrvComboBox

  TBtrvComboBox Component

Properties

Unit

BtrvCmp2

Parent

TComboBox

Description

A TBtrvComboBox is an Editing Component.  TBtrvComboBox allows the programmer to populate the list with values, not from a Btrieve data file and have the selected value written to the record of the BtrvFile of the TBtrvListBox.  Additional items entered into TBtrvComboBox are not stored to any Btrieve file.

See Also

TBtrvListBox


TBtrvCheckBox

  TBtrvCheckBox Component

Properties

Unit

BtrvCmp1

Parent

TCheckBox

Description

TBtrvCheckBox is an Editing Component.  TBtrvCheckBox reads and writes from one BtrvFile, with BtrvTrue and BtrvFalse defaulting to one character Strings, Y and N, but modifiable.

The True and False values are set to any available ConversionType and BtrvLength.  This allows the use of a True value of Pizza and a False value of Hamburger.  This could be done with an BtrvOffset of 17, BtrvLength of 9, BtrvType of dbString.  If the information being read from the database matches True, the box will be checked, otherwise the box is not checked.  If the user clicks on the CheckBox, the new True or False value will be written to the database.

See Also

TBtrvCheckBitBox


TBtrvCheckBitBox

  TBtrvCheckBitBox Component

Properties

Unit

BtrvCmp1

Parent

TCheckBox

Description

TBtrvCheckBitBox is an Editing Component.  TBtrvCheckBitBox reads and writes from the same BtrvFile, but uses only one bit of the byte at the Offset.  The assignments of True and False are not modifiable.  This component can allow 8 True/False values to be stored in the same byte as would be used by one TBtrvCheckBox.  Multiple TBtrvCheckBitBoxes may be directed at different bits within the same byte of a record.

Values	Bit Value

True	1

False	0


TBtrvRadioButton

  TBtrvRadioButton Component

Properties

Unit

BtrvCmp1

Parent

TRadioButton

Description

TBtrvRadioButton is an Editing Component.  TBtrvRadioButton reads and writes from one BtrvFile, with True and False defaulting to Y and N, but modifiable.  All of the TBtrvRadioButtons do not have to point to the same bytes of the record.  The TBtrvRadioButton component will make sure only the appropriate TBtrvRadioButton has a True value written in the BtrvFile at any time.  This allows the use of legacy tables where three of the six radio buttons in a GroupBox all point to the same record location, but the other three each have their own position in the record.

Note: Do not use other radio buttons in the same group as a TBtrvRadioButton.  This is caused by Borlands declaration of SetChecked as protected in their VCL, which does not allow us to override it from other units when inherited.


TBtrvEdit

  TBtrvEdit Component

Properties

Unit

BtrvCmp1

Parent

TEdit

Description

TBtrvEdit is an Editing Component.  TBtrvEdit reads and writes from one BtrvFile.


TBtrvMemo

  TBtrvMemo Component

Properties

Unit

BtrvCmp1

Parent

TMemo

Description

TBtrvMemo is an Editing Component.  TBtrvMemo reads and writes from the same BtrvFile.


TBtrvNavigator

  TBtrvNavigator Component

Properties

Unit

BtrvCmp1

Parent

TDBNavigator

Description

TBtrvNavigator is a Miscellaneous Component,  TBtrvNavigator is a set of buttons that allow First, Previous, Next, Last, Insert, and Delete methods to be accessed from the BtrvFile of the component.


TBtrvDB Methods

Methods

AbortTransaction

BeginTransaction

CreateFile

EndTransaction

ExecBtrvFunction

GetDirectory

GetVersion

Reset

SetDirectory

Stop


TBtrvDB Properties

Properties

SerialNumber


SerialNumber

SerialNumber Property

Applies to

TBtrvDB component

Declaration

property SerialNumber: LongInt;

Description

The SerialNumber Property is a read-only value that validates your license of Btrieve Components for Delphi.  When contacting Summit National Group for support or inquiries about customizations, this SerialNumber will identify you as a valid licensee.


Methods

Close

Delete

GetDirect

GetEqual

GetFirst

GetGreaterThan

GetGreaterThanOrEqual

GetLast

GetLessThan

GetLessThanOrEqual

GetNext

GetNextExtended

GetPosition

GetPrevious

GetPreviousExtended

Insert

Open

SendNewData

Stat

StatForCreate

Unlock

Update

UpdateComponents


Open

Open Method

Applies to

TBtrvFile

Declaration

procedure Open(BtrvOwnerName:PChar;AccessMode:AccessModeType);

Parameters

AccessModeType

Description

The Open method makes a Btrieve file available to access.  It opens the Btrieve File listed in the DataFile property at the DataPath location.  Identical to Btrieve Open.


Close

Close Method

Applies to

TBtrvFile

Declaration

procedure Close;

Description

The Close method closes an open Btrieve file, releases all locks, and flushes all buffers.  It closes the Btrieve File associated with the TBtrvFile.


GetDirectory

GetDirectory Method

Applies to

BtrvDB

Declaration

function GetDirectory(KeyNumber:Integer):string;

Description

This is the Btrieve Get Directory command. KeyNumber  is the number that should normally be specified in the Key Number parameter i.e. 1 for A, 2 for B etc. .

See Also

SetDirectory


SetDirectory

SetDirectory Method

Applies to

BtrvDB

Declaration

procedure SetDirectory(FileName:string);

Description

Sets the directory Btrieve is currently using.

See Also

GetDirectory


Reset

Reset Method

Applies to

BtrvDB

Declaration

function Reset;

Description

Executes the Btrieve Reset function.  Releases all Btrieve Files.


Stop

Stop Method

Applies to

BtrvDB

Declaration

function Stop;

Description

Executes the Btrieve Stop function.  Releases all Btrieve Files.


AbortTransaction

AbortTransaction Method

Applies to

BtrvDB

Declaration

procedure AbortTransaction;

Description

Executes the Btrieve AbortTransaction function.


BeginTransaction

BeginTransaction Method

Applies to

BtrvDB

Declaration

procedure BeginTransaction;

Description

Executes the Btrieve BeginTransaction function.


EndTransaction

EndTransaction Method

Applies to

BtrvDB

Declaration

procedure EndTransaction;

Description

Executes the Btrieve EndTransaction function.


TBtrvDriverListBox Properties

Properties

Btrv1Length

Btrv1Offset

Btrv1Type

Btrv2Length

Btrv2Offset

Btrv2Type

Btrv3Length

Btrv3Offset

Btrv3Type

BtrvFile

Chained

Filter


BtrvFile Members
Member

RecordBuffer


TBtrvFile Properties

Properties

AccessMode

AutoWrite

DataExtension

DataFile

DataPath

DoKey

DoLocking

KeyNumber

LockingLevel

BtrvOwner


ExecBtrvFunction

ExecBtrvFunction Method

Applies to

TBtrvDB

Declaration

procedure ExecBtrvFunction(OpCode: Integer, var PositionBlock: PositionType, DataBuffer: -TBtrvStream, KeyBuffer: TBtrvStream, KeyNumber: Integer);

Parameters

OpCode

PositionBlock

DataBuffer

KeyBuffer

KeyNumber

Description

Executes a Btrieve Function directly.


CreateFile

CreateFile Method

Applies to

TBtrvDB

Declaration

procedure CreateFile(DataBuffer:TBtrvStream;Filename:Pchar);

Description

Equivalent to the Btrieve Create command.  The data used for the create ( as described in The Brieve Programmers Manual )  is written into DataBuffer. Filename is a C-string which contains the name of the file.

Suggested Use:  Create a file using the Btrieve File Manager that comes with the Btrieve Developers Kit.  The DataBuffer can then be read in using the TBtrvFile command StatForCreate.  One can then use the WriteStreamToFile and ReadStreamFromFile methods of TMemoryStream.


Source Component

Source components actually do the work of reading and writing to and from the Btrieve data file.

Source Components

TBtrvDB

TBtrvFile

See Also

Driver Component

Editing Component

Lookup Component

Miscellaneous Component


Editing Component

Editing components interact with the application user in updating and inserting information into the Btrieve data file for specific records.

Editing Components

TBtrvEdit

TBtrvMemo

TBtrvListBox

TBtrvComboBox

TBtrvRadioButton

TBtrvCheckBox

TBtrvCheckBitBox

See Also

Source Component

Driver Component

Lookup Component

Miscellaneous Component


Lookup Component

Lookup components read their information from one BtrvFile and write the selected field into a second BtrvFile.

Lookup Components

TBtrvLookupListBox

TBtrvLookupComboBox

See Also

Source Component

Driver Component

Editing Component

Miscellaneous Component


Miscellaneous Component

Miscellaneous Component

TBtrvNavigator

See Also

Source Component

Driver Component

Editing Component


Chain Property

Applies to

TBtrvDriverListBox components

Declaration

property Chain: TBtrvDriverListBox;

Description

The Chain property allows a Driver Component to send the selected item to the Chained TBtrvDriverListBox component which would then populate, using the selected item as a filter on its list.  This continues until the Chain property of the TBtrvDriverListBox is nil, then the selection of an item populates the Editing Components on the form that have the same BtrvFile.


TBtrvDriverComboBox Methods

Methods


TBtrvDriverComboBox Properties

Properties

Btrv1Length

Btrv1Offset

Btrv1Type

Btrv2Length

Btrv2Offset

Btrv2Type

Btrv3Length

Btrv3Offset

Btrv3Type

BtrvFile

Filter


BtrvCmp1 Unit

The BtrvCmp1 unit contains declarations for the components that appear on the Btrieve page of the Component palette and their associated objects, types, and contents.

The following items are declared in the BtrvCmp1 Unit:

Components

TBtrvDB

TBtrvFile

TBtrvMemo

TBtrvEdit

TBtrvListBox

TBtrvComboBox

TBtrvRadioButton

TBtrvCheckBitBox

TBtrvCheckBox

TBtrvDriverComboBox

TBtrvDriverListBox

TBtrvLookupListBox

TBtrvLookupComboBox

TBtrvNavigator

Classes

EBtrvException

EComponentException

Types

ComparisonType

LogicType

ComStoredFieldOrGiven

AccessModeType

CurrencyType

PositionType

VersionType

ConversionType

KeyType

BtrvType

Constants

KeyBufferLength: Integer	= 255;

MaxDataBufferSize: Word	= $4000; {FC00 should work, but just to be safe}

Uses

WinTypes, WinProcs, Classes, StdCtrls, SysUtils Borland International Files

BtrvCmp2: Summit National Group, Inc. Files

BTRAPIW, BTRCONST: Btrieve Technologies, Inc. Files.


BtrvCmp2 Unit

The BtrvCmp2 unit contains declarations for the components that appear on the Btrieve page of the Component palette and their associated objects, types, and contents.

The following items are declared in the BtrvCmp2 Unit:

Components

TBtrvListBox

TBtrvComboBox

TBtrvLookupListBox

TBtrvLookupComboBox

TBtrvDriverComboBox

TBtrvDriverListBox

TBtrvNavigator

Uses

WinTypes, WinProcs, Classes, StdCtrls, SysUtils Borland International Files

BtrvCmp1: Summit National Group, Inc. Files

BTRAPIW, BTRCONST: Btrieve Technologies, Inc. Files.


TBtrvLookupListBox Properties

Properties

Btrv1Length

Btrv1Offset

Btrv1Type

Btrv2Length

Btrv2Offset

Btrv2Type

Btrv3Length

Btrv3Offset

Btrv3Type

BtrvFile

BtrvLength

BtrvOffset

BtrvReadFile

BtrvType

Filter


TBtrvLookupComboBox Properties

Properties

Btrv1Length

Btrv1Offset

Btrv1Type

Btrv2Length

Btrv2Offset

Btrv2Type

Btrv3Length

Btrv3Offset

Btrv3Type

BtrvFile

BtrvLength

BtrvOffset

BtrvReadFile

BtrvType

Filter


TBtrvListBox Properties

Properties

BtrvAddNewItem

BtrvFile

BtrvLength

BtrvOffset

BtrvType


TBtrvComboBox Properties

Properties

BtrvAddNewItem

BtrvFile

BtrvLength

BtrvOffset

BtrvType


TBtrvCheckBox Properties

Properties

BtrvFalse

BtrvFile

BtrvLength

BtrvOffset

BtrvTrue

BtrvType


TBtrvCheckBitBox Properties

Properties

BtrvBit

BtrvFile

BtrvOffset


TBtrvRadioButton Properties

Properties

BtrvFalse

BtrvFile

BtrvLength

BtrvOffset

BtrvTrue

BtrvType


TBtrvEdit Properties

Properties

BtrvFile

BtrvLength

BtrvOffset

BtrvType

All other properties are inherited from TEdit.


TBtrvMemo Properties

Properties

BtrvFile

BtrvLength

BtrvOffset

BtrvType


TBtrvNavigator Properties

Property

BtrvFile


BtrvOffset Property

Applies to

TBtrvEdit, TBtrvMemo, TBtrvListBox, TBtrvComboBox, TBtrvRadioButton, TBtrvCheckBitBox, TBtrvCheckBox, TBtrvDriverComboBox, TBtrvDriverListBox, TBtrvLookupListBox, TBtrvLookupComboBox components

Declaration

property BtrvOffset: Integer;

Description

The BtrvOffset property determines at what position of the BtrvFiles current record the component will start reading and writing its information.  In the case of TBtrvLookupListBox, and TBtrvLookupComboBox, this parameter is for writing only.


BtrvLength Property

Applies to

TBtrvEdit, TBtrvMemo, TBtrvListBox, TBtrvComboBox, TBtrvRadioButton, TBtrvCheckBitBox, TBtrvCheckBox, TBtrvDriverComboBox, TBtrvDriverListBox, TBtrvLookupListBox, TBtrvLookupComboBox components

Declaration

property BtrvLength: Integer;

Description

The BtrvLength property determines how many positions from the Offset of the BtrvFiles current record the component will read and write its information.  In the case of TBtrvLookupListBox, and TBtrvLookupComboBox, this parameter is for writing only.


BtrvType Property

Applies to

TBtrvEdit, TBtrvMemo, TBtrvListBox, TBtrvComboBox, TBtrvRadioButton, TBtrvCheckBitBox, TBtrvCheckBox, TBtrvDriverComboBox, TBtrvDriverListBox, TBtrvLookupListBox, TBtrvLookupComboBox components

Declaration

property BtrvType: ConversionType;

Description

The BtrvType property determines the data conversion that occurs on the read and write of the information from the Btrieve data file and the component.  In the case of TBtrvLookupListBox, and TBtrvLookupComboBox, this parameter is for writing only.


BtrvFile Property

Applies to

TBtrvEdit, TBtrvMemo, TBtrvListBox, TBtrvComboBox, TBtrvRadioButton, TBtrvCheckBitBox, TBtrvCheckBox, TBtrvDriverComboBox, TBtrvDriverListBox, TBtrvLookupListBox, TBtrvLookupComboBox, TBtrvNavigator components

Declaration

property BtrvFile: TBtrvFile;

Description

The BtrvFile property determines which TBtrvFile component the component will be accessing for its data.  In the case of TBtrvLookupListBox, and TBtrvLookupComboBox, this parameter is for writing only.


BtrvReadFile Property

Applies to

TBtrvLookupListBox, TBtrvLookupComboBox, components

Declaration

property BtrvReadFile: TBtrvFile;

Description

The BtrvReadFile property determines which TBtrvFile component the component will be accessing for the read of its data.


AccessMode Property

Applies to

TBtrvFile components

Declaration

property AccessMode: AccessModeType;

Description

The AccessMode property determines the type of access that the present TBtrvFile will be allowed.


AutoWrite

AutoWrite Property

Applies to

TBtrvFile component

Declaration

property AutoWrite: Boolean;

Description

The AutoWrite property determines whether an Update Command is executed automatically immediately before the execution of a GetFirst, GetNext, GetLast or GetPreviouscommand.


DataExtension

DataExtension Property

Applies to

TBtrvFile components

Declaration

property DataExtension: Array[0..4] of Char;

Description

The DataExtension property is the extension of the file that TBtrvFile is accessing.


DataFile

DataFile Property

Applies to

TBtrvFile components

Declaration

property DataFile: Array[0..10] of Char;

Description

The name (without extension) of the Btrieve file that TBtrvFile is accessing.


DataPath

DataPath Property

Applies to

TBtrvFile components

Declaration

property DataPath: Array[0..242] of Char;

Description

The path of the file that TBtrvFile


Name Property

Applies to

All Btrieve Components for Delphi

Declaration

property Name: string[63];

Description

The Name property contains the name of the component.


BtrvOwner Property

Applies to

TBtrvFile

Declaration

property BtrvOwner: Array[0..8] of Char;

Description

The BtrvOwner property contains the owner of the Btrieve data file being accessed.


PathName Property

DataPath Property

Applies to

TBtrvFile

Declaration

property DataPath: Array[0..242] of Char;

Description

The DataPath property contains the path to the Btrieve data file being accessed and identified in the DataFile property.


EBtrvException

Property

Parent

Exception

Description

EBtrvException is raised when Btrieve returns a non zero status message.


EBtrvProperties

Properties

Error


BtrvError

Error Property

Applies to

EBtrvException

Declaration

Error:Integer;

Description

Error contains the value of the Btrieves Status Code.


EComponentException

Property

Parent

Exception

Description

This is an exception that is raised when an inconsistency in the components is encountered.


CompProperties

Property

Error


JCompError

Error

Applies to

EComponentException

Declaration

Error:Integer;

Description

Contains the Component Error Number


Component Error Number

Value	Description

0	Multiple TBtrvDBs are present in the application.

Only one TBtrvDB should be present in any application, on the MainForm.

1	A BtrvField was created with a wrong integer size.

BtrieveComponents only support integers of size 2 (short) and 4 (long).

2	A BtrvField was created with a wrong float size

BtrieveComponents only support float types of  4(real) and 8(double).

3	DoKey done with negative Keynumber.

Negative KeyNumbers imply a Step Operation. The Key operation only works with the Get operations (see Btrieve Programmers Manual).

4	No filename was specified in a TBtrvFIle.

5	BtrvOwnerName has more than 8 characters.

6	A BtrvField was not created.  This error is thrown because an illegal type is specified.

7	A value was read from the Btrieve file which was not present in the list (called from a listbox).

8	In reading a record from the data buffer returned from an extended read, a record beyond the end of the databuffer was read.

9	In an unchained DriverListBox or a DriverComboBox, a  record was clicked that did not have a unique value.


Filter Property

Applies to

TBtrvDriverComboBox, TBtrvDriverListBox, TBtrvLookupComboBox, TBtrvLookupListBox components

Declaration

property Filter: TFilter

Description

The Filter property stores the applicable filter for the object, if a filter is necessary.


KeyNumber

KeyNumber Parameter

Applies to

ExecBtrvFunction function

Declaration

KeyNumber: Integer

Description

Identifies the current index for searching.


PositionBlock

PositionBlock Parameter

Applies to

ExecBtrvFunction function

BtrvType

var PositionType

Description

The PositionBlock is the parameter passed to Btrieve as the Position Block.  For more information see the Btrieve Programmers Manual.

Note: The only time this parameter should ever be used is when a programmer is making direct calls to ExecBtrvFunction.  For all component calls TBtrvFile maintains its own position block.


DataBuffer

DataBuffer Parameter

Applies to

ExecBtrvFunction function

BtrvType

TBtrvStream

Description

The memory property of the DataBuffer points to the block that is passed to Btrieve as the databuffer.  For more information see the Btrieve Programmers manual.


KeyBuffer

KeyBuffer Parameter

Applies to

ExecBtrvFunction function

BtrvType

TBtrvStream

Description

The memory property of the KeyBuffer points to the block that is passed to Btrieve as the keybuffer.  For more information see the Btrieve Programmers manual.


TBtrvStream

TBtrvStream Class

Methods

Parent

ABtrvStream

Description

TBtrvStream is a derivative of TMemoryStream meant to hold data passed to and from Btrieve.

Along with the standard TMemoryStream methods, TBtrvStream contains several methods which

are useful in reading and writing data from Btrieve


TBtrvStream Methods

Methods

ReadFixedType

ReadVariableType

WriteFixedType

WriteVariableType

ReadField

WriteField


ReadFixedType Method

Applies to

TBtrvStream class

Declaration

procedure ReadFixedType( var Field, Offset: Integer, FieldType: TBtrvType);

Parameters

Field

Offset

TBtrvType

Description

Reads information into Field from the RecordBuffer.

See Also

ReadVariableType

WriteFixedType

WriteVariableType

ReadField

WriteField


ReadVariableType Method

Applies to

TBtrvStream class

Declaration

procedure ReadVariableType( var Field, Offset: Integer, Length: Integer);

Parameters

Field

Offset

Length

Description

Reads information into Field from the RecordBuffer.

See Also

ReadFixedType

WriteFixedType

WriteVariableType

ReadField

WriteField


WriteFixedType Method

Applies to

TBtrvStream class

Declaration

procedure WriteFixedType(var Field, Offset: Integer, FieldType: TBtrvType);

Parameters

Field

Offset

TBtrvType

Description

Places the information in Field into the RecordBuffer.

See Also

ReadFixedType

ReadVariableType

WriteVariableType

ReadField

WriteField


WriteVariableType Method

Applies to

TBtrvStream class

Declaration

procedure WriteVariableType( var Field, Offset: Integer, Length: Integer);

Parameters

Field

Offset

Length

Description

Places the information in Field into the RecordBuffer.

See Also

ReadFixedType

ReadVariableType

WriteFixedType

ReadField

WriteField


ReadField Method

Applies to

TBtrvStream class

Declaration

procedure ReadField( Field: TBtrvField);

Parameter

TBtrvField

Description

Reads the Field

See Also

ReadFixedType

ReadVariableType

WriteFixedType

WriteVariableType

WriteField


WriteField Method

Applies to

TBtrvStream class

Declaration

procedure WriteField( Field: TBtrvField);

Parameter

TBtrvField

Description

Writes the Field

See Also

ReadFixedType

ReadVariableType

WriteFixedType

WriteVariableType

ReadField


ComparisonType

Unit

BtrvCmp1

Values	Description

NoComp	No comparison will be used

Equal	Both values must match exactly

GreaterThan	The value being tested must have a greater value that the Comparison value

LessThan	The value being tested must have a lesser value that the Comparison value

GreaterThanEqual	The value being tested must have an equal or greater value that the Comparison value

LessThanEqual	The value being tested must have an equal or lesser value that the Comparison value


LogicType

Unit

BtrvCmp1

Values	Description

BDLast	Last

BDAnd	And

BDOr	Or


AccessModeType

Unit

BtrvCmp1

Values	Description

Normal	Integer 0.  Normal Access Mode

Accelerated	Integer -1.

ReadOnly	Integer -2.  The application can only read the file.  This modes allows a file with corrupt data to be opened and the data recovered using the Step Next function.

Verify	Integer -3.  Btrieve for Windows v6.15 disregards this option and opens the file using Normal.

Exclusive	Integer -4.  The application has exclusive access to the file.  No other application can open that file until the application closes the file.

The following are not implemented at this time.

SEFS	Integer -32.  Single Engine File Sharing.  This bias only works if the EnableSharingBias option is turned on in the BTI.INI file.  Use this mode when you want to open a file in SEFS mode and the default file sharing mode for the workstation drive is MEFS.

MEFS	Integer -64.  Multi-Engine File Sharing.  This bias works only if the EnableSharingBias option is turned on in the BTI.INI file.  Use this mode when you want to open a file in MEFS mode and the default file sharing mode for the workstation drive is SEFS.


CurrencyType

Unit

BtrvCmp1

Values

KeepPosition

LosePosition


KeyType

Unit

BtrvCmp1

Code	Values	Type

0	bdString	String

1	bdInteger	Integer

2	bdFloat	Float

3	bdDate	Date

4	bdTime	Time

5	bdDecimal	Decimal

6	bdMoney	Money

7	bdLogical	Logical

8	bdNumeric	Numeric

9	bdBFloat	BFloat

10	bdLString	LString

The following are not implemented at this time

11	bdZString	ZString

14	bdUnsignedBinary	Unsigned Binary

15	bdAutoIncrement	AutoIncrement

17	bdSignTrailingSeperate	Sign Trailing Separate


PositionType

Unit

BtrvCmp1

Applies To

ExecBtrvFunction, GetDirect, GetPosition methods

Definition

Array[0..127] of char;

Description

Memory that maintains logical positioning information for use in accessing records.

Information kept includes:

Current index path identifier

Logical Previous record pointer

Current record pointer to the most recently accessed record.

Logical Next record pointer

Note:	Your application should never write to the position block, because this could result in a lost position error, other errors, or damage to the Btrieve file.


VersionType

Unit

BtrvCmp1

Definition

Array[0..14] of char;

Description

From a workstation, Version is the client-based engine version and the current requester version.

From a server, or with a specified file path in the key buffer.


BtrvTrue Property

Applies to

TBtrvCheckBox, TBtrvRadioButton components

Declaration

property BtrvTrue: String

Description

This value is used to write to the database when the Checked value is changed to True. In order for the TBtrvCheckBox Checked property to be set to True, this string must match the information being read through BtrvOffset, BtrvLength, and BtrvType.


BtrvFalse Property

Applies to

TBtrvCheckBox, TBtrvRadioButton components

Declaration

property BtrvFalse: String

Description

This string  is used to write to the database when the Checked value is changed to False.


EBtrvException Example

Example

This code segment identifies whether the error is generated by the component or Btrieve.

try

  BtrvFile1.GetPrevious;

except

  On ExceptionInstance:EBtrvException do

    Begin

      With ExceptionInstance do

        If BtrvError <> 0 Then MessageDlg(Btrieve Error,mtCustom,[mbOk],0);

        If ComponentError <> 0 Then MessageDlg(Component Error,mtCustom,[mbOk],0);

    End;

  End;


Btrieve Status Codes

Value	Description

0	Operation OK

2	I/O Error

3	File Not Opened

4	Key Value Not Found

5	Duplicate Key Value

6	Invalid Key Number

7	Different Key Number

8	Invalid Positioning

9	End of File

10	Modifiable Key Value Error

11	Invalid File Name

12	File Not Found

13	Extended File Error

14	Pre-Image Open Error

15	Pre-Image I/O Error

16	Expansion Error

17	Close Error

18	Disk Full

19	Unrecoveragle Error

20	Record Manager Inactive

21	Key Buffer Too Short

22	Data Buffer Length

23	Position Block Length

24	Page Size Error

25	Create I/O Error

26	Number of Keys

27	Invalid Key Position

28	Invalid Record Length

29	Invalid Key Length

30	Not a Btrieve File

31	File already Extended

32	Extend I/O Error

34	Invalid Extension Name

35	Directory Error

36	Transaction Error

37	Transaction is Active

38	Transaction Control File I/O Error

39	End/Abort Transaction Error

40	Transaction Max Files

41	Operation Not Allowed

42	Incomplete Accelerated Access

43	Invalid Record Address

44	Null Key Path

45	Inconsistent Key Flags

46	Access to file Denied

47	Maximum open Files

48	Invalid Alternate Sequence Definition

49	Key Type Error

50	Owner Already Set

51	Invalid Owner

52	Error Writing Cache

53	Invalid Interface

54	Variable Page Error

55	Autoincrement Error

56	Incomplete Index

57	Expanded Memory Error

58	Compression Buffer too Short

59	File Already Exists

60	Reject Count Reached

61	Work Space Too Small

62	Incorrect Description

63	Invalid Extended Insert Buffer

64	Filter Limit Reached

65	Incorrect Field Offset

74	Automatic Transaction Abort

78	Deadlock Detected

80	Conflict Error

81	Lock Error

82	Lost Position

83	Read Outside Transaction

84	Record Locked

85	File Locked

86	File Table Full

87	Handle Table Full

88	Incompatible Mode Error

90	Redirection Device Table Full

91	Server Error

92	Transaction Table Full

93	Incompatible Lock Type

94	Permission Error

95	Session No Longer Valid

96	Communications Environment Error

97	Data Message too Small

98	Internal Transaction Error


Biases

Value	Description

+50	Key-Only Operation Bias

+100	Single-Record Wait Lock Bias

+200	Single-Record NoWait Lock Bias

+300	Multiple-Record Wait Lock Bias

+400	Multiple-Record NoWait Lock Bias


Conversion Type

Values

dbShortInt, dbLargeInt, dbSingle, dbDouble, dbString, dbByte (One byte field.  Used primarily in TBtrvCheckBitBox), dbDate, dbTime, dbGraphic


Btrieve Operation Codes

Operation	Operation Code

Abort Transaction	21

Begin Transaction	19

Clear Owner	30

Close	1

Create	14

Create Supplemental Index	31

Delete	4

Drop Supplemental Index	32

End Transaction	20

Extend	16

Get Direct	23

Get Directory	18

Get Equal	5

Get First	12

Get Greater Than	8

Get Greater Than Or Equal	9

Get Last	13

Get Less Than	10

Get Less Than Or Equal	11

Get Next	6

Get Next Extended	36

Get Position	22

Get Previous	7

Get Previous Extended	37

Insert	2

Insert Extended	40

Reset	28

Set Directory	17

Set Owner	29

Stat	15

Step First	33

Step Last	34

Step Next	24

Step Next Extended	38

Step Previous	35

Step Previous Extended	39

Stop	25

Unlock	27

Update	3

Version	26


BtrvBit Property

Applies to

TBtrvCheckBitBox component

Declaration

property BtrvBit: Integer;

Description

BtrvBit identifies the bit of the byte at BtrvOffset that determines the value of TBtrvCheckBitBox.  A byte is made up of eight bits numbered from right to left, 0 to 7: 76543210.

During a Read:

If the bit is 1, then the TBtrvCheckBitBox Checked property is set to True.  If the bit is 0, then the TBtrvCheckBitBox Checked Property is set to False.

When the TBtrvCheckBitBox is toggled:

If TBtrvCheckBitBox.Checked is True, then the bit is set to 1, else the bit is set to 0.


BtrvAddNewItem Property

Applies to

TBtrvComboBox, TBtrvListBox components

Declaration

property BtrvAddNewItem: Boolean;

Description

BtrvAddNewItem determines whether the item being read from the BtrvFile will be automatically added to the list if it does not exist in the list.  If the value is True, then the BtrvFile value is added to the list if it is not in the list.  If the value is False, then an exception is thrown when the BtrvFile value is not in the list.


BtrvCompInstallation

Btrieve Components for Delphi Installation

The Btrieve Components for Delphi are delivered on two disks.  The Help file is on the disk labeled Btrieve Components for Delphi Help.  Inside the sealed envelope is the disk with the components that is labeled Btrieve Components for Delphi Components.  The Help file is packaged separately from the components so that it may be reviewed before opening the envelope.  Registration of your product is done at time of purchase.

Note:	Please read the label on the sealed envelope before opening the envelope.

We recommend printing this topic before installation.

The installation process has four steps:

1. Copy the Help files.

A. Copy BTRVCOMP.HLP to the \DELPHI\BIN directory of your Delphi installation from the Btrieve Components for Delphi Help Disk.

B. Copy BTRVCOMP.KWF to the \DELPHI\HELP directory of your Delphi installation from the Btrieve Components for Delphi Help Disk.

2. Copying the Component files to your directory of choice.  We recommend you create a BTRVCOMP directory into which you place all your component files.

A. Copy BTRVCMP1.DCU, BTRVCMP2.DCU, BTRVCMP1.DCR, BTRVCMP2.DCR, BTRVCMP1.RES, BTRAPIW.DCU, BTRCONST.DCU to the directory you have chosen for your component files from the Btrieve Components for Delphi Components Disk.

3. Integrating the Help file with the Delphi Help system. Make sure Delphi is not running during this step.

1. Run HelpInst in the Delphi Group.

2. File, Open \DELPHI\BIN\DELPHI.HDX

3. Keywords, Add Keyword File \DELPHI\HELP\BTRVCOMP.KWF

4. File, Save

5. File, Exit

4. Adding the components to the Delphi palette.

A. Start Delphi and choose Options, Install Components...

B. In the Install Components Dialog Box, click on the Add button.

C. In the Add Module Dialog Box, click on the Browse button.

D. Change the List Files of Type combo box to show Unit File (*.DCU)

E. Maneuver to the directory you have chosen previously for you Btrieve Components for Delphi and either double-click on BTRVCMP1.DCU or select BTRVCMP1.DCU and click on the Ok button.

F. Verify that Btrvcmp1 is listed in the Installed Units list box.

G. In the Install Components Dialog Box, click on the Add button.

H. In the Add Module Dialog Box, click on the Browse button.

I. Change the List Files of Type combo box to show Unit File (*.DCU)

J. Maneuver to the directory you have chosen previously for you Btrieve Components for Delphi and either double-click on BTRVCMP2.DCU or select BTRVCMP2.DCU and click on the Ok button.

K. Verify that Btrvcmp2 is listed in the Installed Units list box.

L. Click on the OK button.  Delphi will now add the components to your palette.

Congratulations on your purchase.


GetLast

GetLast Method

Applies To

TBtrvFile components

Declaration

procedure GetLast;

Description

The GetLast Method retrieves the logical last record in the current key path.  Identical to Btrieve GetLast.


GetNext

GetNext Method

Applies To

TBtrvFile components

Declaration

procedure GetNext;

Description

The GetNext Method retrieves the logical next record in the current key path.  Identical to Btrieve GetNext.


DoLocking

DoLocking Property

Applies To

TBtrvFile components

Definition

property DoLocking: Boolean;

Description

When True, the DoLocking property will enforce the given LockingLevel upon the Btrieve file.  When False, locking will not be enforced upon the file.


Delete

Delete Method

Applies To

TBtrvFile components

Declaration

procedure Delete(PositionState:CurrencyType);

Parameter

CurrencyType

Description

The Delete Method removes the current record from the file.  Identical to Btrieve Delete.


GetEqual

GetEqual Method

Applies To

TBtrvFile components

Declaration

procedure GetEqual(EqualVal:TBtrvField);

Parameter

TBtrvField

Description

The GetEqual Method retrieves the first record with a key value equal to the TBtrvField.  Identical to Btrieve GetEqual.


GetFirst

GetFirst Method

Applies To

TBtrvFile components

Declaration

procedure GetFirst;

Description

The GetFirst Method retrieves the logical first record in the current key path.  Identical to Btrieve GetFirst.


Insert

Insert Method

Applies To

TBtrvFile components

Declaration

procedure Insert(PositionState:CurrencyType);

Parameter

CurrencyType

Description

The Insert method inserts the record in the RecordBuffer into the Btrieve file.  Identical to Btrieve Insert.


UpdateComponents

UpdateComponents Method

Applies To

TBtrvFile components

Declaration

procedure UpdateComponents;

Description

The UpdateComponents method calls the UpdateComponent callback function of each component that is attached to the TBtrvFile.  This method makes sure that the attached components have the correct information from the TBtrvFile.


SendNewData

SendNewData Method

Applies To

TBtrvFile components

Declaration

procedure SendNewData(PositionState:CurrencyType);

Parameter

CurrencyType

Description

The SendNewData method calls the SendNewData callback function of each component that is attached to the TBtrvFile.  This method makes sure that the RecordBuffer is current before any writing to the Btrieve file occurs.


GetGreaterThanOrEqual

GetGreaterThanOrEqual Method

Applies To

TBtrvFile components

Declaration

procedure GetGreaterThanOrEqual(Value:TBtrvField);

Parameter

TBtrvField

Description

The GetGreaterThanOrEqual Method retrieves the first record with a key value greater than or equal to the TBtrvField.  Identical to Btrieve GetGreaterOrEqual.


GetPosition

GetPosition Method

Applies To

TBtrvFile components

Declaration

function GetPosition:PositionType;

Return Value

PositionType

Description

The GetPosition method returns the four-byte physical address of the current record.  Identical to Btrieve GetPosition.


GetPrevious

GetPrevious Method

Applies To

TBtrvFile components

Declaration

procedure GetPrevious;

Description

The GetPrevious Method retrieves the previous record in the current key path.  Identical to Btrieve GetPrevious.


KeyNumber

KeyNumber Property

Applies To

TBtrvFile components

Definition

property KeyNumber: Integer;

Description

The KeyNumber property is the value of the key currently being used by TBtrvFile.  The rules of when are valid times to change this value follow Btrieves rules.

Note: For nonnegative KeyNumbers the Get version of the Btrieve command is executed. For negative KeyNumbers the Step version of the Btrieve command is executed.


GetLessThan

GetLessThan Method

Applies To

TBtrvFile components

Declaration

procedure GetLessThan(Value:TBtrvField);

Parameter

TBtrvField

Description

The GetLessThan Method retrieves the last record with a key value less than the TBtrvField.  Identical to Btrieve GetLessThan.


LockingLevel

LockingLevel Property

Applies To

TBtrvFile components

Definition

property LockingLevel: Biases;

Description

The LockingLevel property indicates what level of locking will be enforced upon the Btrieve file when the DoLocking property is True.

Note: If the LockingLevel is None and DoLocking is True, then any change to LockingLevel will not be enforced.


KeyBuffer


GetDirect

GetDirect Method

Applies To

TBtrvFile components

Declaration

procedure GetDirect(PositionState:PositionType);

Parameter

PositionType

Description

The GetDirect Method retrieves the record by its four-byte record address.  Identical to Btrieve GetDirect.


Unlock

Unlock Method

Applies To

TBtrvFile components

Declaration

procedure Unlock;

Description

The Unlock method releases locks placed on records.  Identical to Btrieve Unlock.


Update

Update Method

Applies To

TBtrvFile components

Declaration

procedure Update(PositionState:CurrencyType);

Parameter

CurrencyType

Description

The Update method overwrites the current record.  Identical to Btrieve Update.


GetPreviousExtended

GetPreviousExtended Method

Applies To

TBtrvFile components

Declaration

procedure GetPreviousExtended(DataBuffer:TBtrvStream);

Parameter

TBtrvStream

Description

The GetPreviousExtended Method retrieves the previous several records in the current key path starting at the current record.  Identical to Btrieve GetPreviousExtended.


GetGreaterThan

GetGreaterThan Method

Applies To

TBtrvFile components

Declaration

procedure GetGreaterThan(Value:TBtrvField);

Parameter

TBtrvField

Description

The GetGreaterThan Method retrieves the first record with a key value greater than the TBtrvField.  Identical to Btrieve GetGreaterThan.


GetNextExtended

GetNextExtended Method

Applies To

TBtrvFile components

Declaration

procedure GetNextExtended(DataBuffer:TBtrvStream);

Parameter

TBtrvStream

Description

The GetNextExtended method retrieves the next several records that pass an optional filter condition.  Identical to Btrieve GetNextExtended.


StatForCreate

StatForCreate Method

Applies To

TBtrvFile components

Declaration

procedure StatForCreate(DataBuffer:TFileStatStream);

Parameter

TFileStatStream

Description

The StatForCreate method creates a TBtrvFile from the DataBuffer.


RecordBuffer

RecordBuffer Member

Applies to

TBtrvFile components

Description

RecordBuffer is an instance of TBtrvStream.  RecordBuffer stores data from Btrieve functions, like the Gets, that return data.


Stat

Stat Method

Applies To

TBtrvFile components

Declaration

procedure Stat(DataBuffer:TFileStatStream);

Parameter

TFileStatStream

Description

The Stat method retrieves information about a Btrieve file.  Identical to Btrieve Stat.


GetLessThanOrEqual

GetLessThanOrEqual Method

Applies To

TBtrvFile components

Declaration

procedure GetLessThanOrEqual(Value:TBtrvField);

Parameter

TBtrvField

Description

The GetLessThan Method retrieves the last record with a key value less than or equal to the TBtrvField.  Identical to Btrieve GetLessThanEqual.


DoKey

DoKey Property

Applies To

TBtrvFile components

Definition

property DoKey: Boolean;

Description

When True, the DoKey property will cause Get functions to execute without returning data, moving through the file.  The KeyNumber should be positive.


BtrvComp Purchase

Btrieve Components for Delphi Purchase Form

To:	Summit National Group, Inc.	Date:____________

230 E. Ohio Street, Suite 601

Chicago, IL 60611

Re:	Order For Btrieve Components For Delphi

I have read the description of the Btrieve Components For Delphi and have viewed the documentation which accompanies the product in the form of an on-line help file. I have determined that these tools are suitable for my purposes.

I understand that the software cannot be returned if the seal on the diskette envelope in disturbed in any way. I also understand that the product is sold as-is and that free telephone support is limited to one hour. By opening the diskette envelope I agree to be bound by the terms of the attached license agreement.

Please mail this form along with your check  to Summit National Group, Inc. or for credit card orders,  you may FAX this form to 312-944-8346.

 Please send:

_____	Copies of Btrieve Components for Delphi at $395.00 each	____________

Sales Tax (Illinois residents only at 8.00%)	____________

Shipping and Handling (All shipments are Federal Express)	                   15.00

Total	____________

Ship To:

Name___________________________________    Company____________________________

Address_______________________________________________________________________

City____________________________________	State_______	Zip Code________________

Telephone_______________________________	FAX________________________________

Method Of Payment:___Check Enclosed	___Visa	___MasterCard	___AMEX

         ___Diners Club	___Discover

Credit Card Account Number______________________________Expiration Date___________

Name On Credit Card  (Please print clearly)___________________________________________

Signature Of Cardholder__________________________________________________________


LICENSE AGREEMENT

1. Grant Of License. This Summit National Group, Inc. License Agreement (License) permits you to use one copy of the Btrieve Components For Delphi (Software) on any single computer, provided the Software is in use on only one computer at any time. If you have multiple Licenses for the Software, then at any time you may have as many copies of the Software in use as you have Licenses.  The Software is in use in a computer when it is loaded into the temporary memory or is installed into the permanent memory such as a hard disk or other permanent storage device. If the Software is permanently installed on a hard disk or other storage device of a computer, then the person authorized to use such computer also may use the Software on a portable computer, laptop and home computer. If such persons authorization to use such computer ceases for any reason such as termination of employment or other reasons, then such persons authority to use the Software on a portable computer, laptop and home computer shall cease.

2. Copyright. The Software is owned by Summit National Group, Inc. and is protected by United States copyright laws and international treaty provisions. Therefore, you must treat the Software like any other copyrighted material, except that you may either (a) make one copy of the Software solely for backup or archival purposes, or (b) transfer the Software to a single hard disk provided you keep the original solely for backup or archival purposes. You may not copy written material accompanying the Software.

3. Other Restrictions. This License is your proof of license to exercise the rights granted herein and must be retained by you. You may not rent or lease the Software, but you may transfer your rights under this License on a permanent basis provided that you transfer this License, the Software and all accompanying written materials, you retain no copies, the recipient agrees to the terms of this License, and Summit National Group is notified in writing of the transfer with the recipient, recipient address, and serial number of the License being transferred in the document. You may not decompile or disassemble the Software.  It the Software is an update, any transfer must include the update and all prior versions.

4. No Warranties. Summit National Group, Inc. disclaims all warranties, either express or implied, including but not limited to implied warranties or merchantability and fitness for a particular purpose, with respect to the Software and any accompanying written materials.

5. No Liability for Consequential Damages. In no event shall Summit National Group, Inc. or its suppliers be liable for any damages whatsoever (including, without limitation, damages for loss of business profits, business interruption, loss of business information or other pecuniary loss) arising out of the use of or inability to use the Software, even if Summit National Group, Inc. has been advised of the possibility of such damages. Because some states do not allow the exclusion or imitations of consequential or incidental damages, the above limitations may not apply to you.

6. Applicable Law.  This agreement is governed by the laws of the State of Illinois.


TFilter

TFilter Class

Properties

Unit

BtrvCmp1

Parent

TPersistent

Descritption

TFilter is a class which holds the data necessary to specify a Filter in a Extended operations.


FilterProperties

Properties

FilterType

Length

Offset

ACS

Comparison

CompareTo

CheckCase

Logic

GivenValue

StoredValue


FilterType

FilterType Property

Applies To

TFilter

Declaration

FilterType:KeyType;

Description

FilterType describes the type of the filter used in the getextended command. See Btrieve manual under GetNextExtended.


FilterLength

Length Property

Applies To

TFilter

Declaration

Length:Integer;

Description

Describes the length of the field being filtered. 0 length means no filtering is done with this filter.


FilterOffset

Offset Property

Applies To

TFilter

Declaration

Offset:Integer

Description

Describes the Offset of the field being filtered.


ACS

ACS Property

Applies To

TFilter

Declaration

ACS:Boolean

Description

ACS is set to true if ACS is used.  For more information see Btrieve manual under GetNextExtended operation.


FilterComparison

Comparison Property

Applies To

TFilter

Declaration

Comparison:ComparisonType;

Description

Set to the type of comparison to be done in the filter.  For more information see Btrieve manual under GetNextExtended.


FilterCompareTo

CompareTo Property

Applies To

TFilter

Declaration

CompareTo:ComStoredFieldOrGiven;

Description

Set to given if the field compared to is a given field.  Set to stored if the field compared to is a stored field. For more information see Btrieve manual under GetNextExtended.


FilterCheckCase

CheckCase Property

Applies To

TFilter

Declaration

CheckCase:Boolean;

Description

True if the bias if the filtering is to be case sensitive.  For more information see Btrieve manual under GetNextExtended


FilterLogic

Logic Property

Applies To

TFilter

Declaration

Logic:LogicType;

Description

Identifies the logic expresion used by the filter.  For more information see Btrieve manual under GetNextExtended.


FilterGivenValue

GivenValue Property

Applies To

TFilter

Declaration

GivenValue:string;

Description

If CompareTo is set to given, then GivenValue should be set to the value of the field used.


FilterStoredValue

StoredValue Property

Applies To

TFilter

Declaration

StoredValue:Word;

Description

If CompareTo is set to stored, then StoredValue should  be set to physical position of the record.


ABtrvStream

ABtrvStream Class

Methods

Unit

BtrvCmp1

Parent

TMemoryStream

Description

ABtrvStream is an extension of TMemoryStream with two new methods, Wipe and NewSize.


Methods

Wipe

NewSize


Wipe

Wipe Method

Applies To

ABtrvStream

Declaration

procedure Wipe;

Description

Fills the memory with nulls.


NewSize
NewSize Method

Applies To

ABtrvStream

Declaration

procedure NewSize(size:Longint);

Description

Calls SetSize and then fills the memory with nulls.


TBtrvField

TBtrvField Class

Methods

Unit

BtrvCmp1

Parent

ABtrvStream

Description

TBtrvField is an abstract base class. It's primary purpose is to provide a type for conversions of Btrieve data to Text Data.


Methods

Create

DataToText

Length

TextToData

NewSize

Copy


FieldCreate

Create Method

Applies to

TBtrvField

Declaration

constructor Create(Offset:integer;Length:integer);

Description

Creates a BtrvField with offset equal to Offset and length equal to Length+1. The extra byte is allocated

to hold a null for C-Strings.


DataToText

DataToText Method

Applies to

TBtrvField

Declaration

function DataToText:String;virtual;abstract;

Description

Abstract method which takes the value in memory and converts it to text.


FieldLength

Length Method

Applies To

TBtrvField

Declaration

function Length: Integer;

Description

Returns the length of the field.


TextToData

TextToData Method

Applies To

TBtrvField

Declaration

procedure TextToData(Data:String);virtual;abstract;

Description

Abstract method, converts Data to its binary form and stores it in the stream memory.


FieldNewSize

NewSize Method

Applies To

TBtrvField

Declaration

procedure NewSize(size:LongInt);

Description

NewSize sets the Size property to size and the length property to size - 1.


Copy

Copy Method

Applies To

TBtrvField

Declaration

function Copy:TBtrvField;virtual;abstract;

Description

Returns a copy of the BtrvField  of the same type with offset and length set to 0.


TFileStatStream

TFileStatStream Class

Methods

Unit

BtrvCmp1

Parent

TBtrvStream

Description

A class designed to hold the information necessary to create a new file.


Methods

RecordLength

NumberKeys


NumberKeys Method

Applies To

TFileStatStream

Declaration

function NumberKeys: Integer;

Description

Returns the number of keys defined in a Btrieve File.


StatRecordLength

RecordLength Method

Applies To

TBtrvFile

Declaration

function RecordLength:integer;

Description

Returns the record length of the BtrvFile.


Btrv1Offset Property

Applies to

TBtrvDriverComboBox, TBtrvDriverListBox, TBtrvLookupListBox, TBtrvLookupComboBox components

Declaration

property Btrv1Offset: Integer;

Description

The Btrv1Offset property determines at what position of the BtrvReadFiles current record the component will start reading its information.  This information will appear in the first column of the list box.


Btrv1Length Property

Applies to

TBtrvDriverComboBox, TBtrvDriverListBox, TBtrvLookupListBox, TBtrvLookupComboBox components

Declaration

property Btrv1Length: Integer;

Description

The Btrv1Length property determines how many positions from the Btrv1Offset of the BtrvReadFiles current record the component will read its information.  This information will appear in the first column of the list box.


Btrv1Type Property

Applies to

TBtrvDriverComboBox, TBtrvDriverListBox, TBtrvLookupListBox, TBtrvLookupComboBox components

Declaration

property Btrv1Type: ConversionType;

Description

The Btrv1Type property determines the data conversion that occurs on the read of the information from the BtrvReadFile data file.  This information will appear in the first column of the list box.


Btrv2Offset Property

Applies to

TBtrvDriverComboBox, TBtrvDriverListBox, TBtrvLookupListBox, TBtrvLookupComboBox components

Declaration

property Btrv2Offset: Integer;

Description

The Btrv2Offset property determines at what position of the BtrvReadFiles current record the component will start reading its information.  This information will appear in the second column of the list box.


Btrv2Length Property

Applies to

TBtrvDriverComboBox, TBtrvDriverListBox, TBtrvLookupListBox, TBtrvLookupComboBox components

Declaration

property Btrv2Length: Integer;

Description

The Btrv2Length property determines how many positions from the Btrv2Offset of the BtrvReadFiles current record the component will read its information.  This information will appear in the second column of the list box.


Btrv2Type Property

Applies to

TBtrvDriverComboBox, TBtrvDriverListBox, TBtrvLookupListBox, TBtrvLookupComboBox components

Declaration

property Btrv2Type: ConversionType;

Description

The Btrv2Type property determines the data conversion that occurs on the read of the information from the BtrvReadFile data file.  This information will appear in the second column of the list box.


Btrv3Offset Property

Applies to

TBtrvDriverComboBox, TBtrvDriverListBox, TBtrvLookupListBox, TBtrvLookupComboBox components

Declaration

property Btrv3Offset: Integer;

Description

The Btrv3Offset property determines at what position of the BtrvReadFiles current record the component will start reading its information.  This information will appear in the third column of the list box.


Btrv3Length Property

Applies to

TBtrvDriverComboBox, TBtrvDriverListBox, TBtrvLookupListBox, TBtrvLookupComboBox components

Declaration

property Btrv3Length: Integer;

Description

The Btrv3Length property determines how many positions from the Btrv3Offset of the BtrvReadFiles current record the component will read its information.  This information will appear in the third column of the list box.


Btrv3Type Property

Applies to

TBtrvDriverComboBox, TBtrvDriverListBox, TBtrvLookupListBox, TBtrvLookupComboBox components

Declaration

property Btrv3Type: ConversionType;

Description

The Btrv3Type property determines the data conversion that occurs on the read of the information from the BtrvReadFile data file.  This information will appear in the third column of the list box.